# coding=utf-8
# *** WARNING: this file was generated by Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
import pulumi_kubernetes

__all__ = ['SecretsStoreCsiDriverArgs', 'SecretsStoreCsiDriver']

@pulumi.input_type
class SecretsStoreCsiDriverArgs:
    def __init__(__self__, *,
                 sync_secret_enabled: pulumi.Input[str]):
        """
        The set of arguments for constructing a SecretsStoreCsiDriver resource.
        :param pulumi.Input[str] sync_secret_enabled: Enable synchronization from volumes to Kubernetes secretes.
        """
        pulumi.set(__self__, "sync_secret_enabled", sync_secret_enabled)

    @property
    @pulumi.getter(name="syncSecretEnabled")
    def sync_secret_enabled(self) -> pulumi.Input[str]:
        """
        Enable synchronization from volumes to Kubernetes secretes.
        """
        return pulumi.get(self, "sync_secret_enabled")

    @sync_secret_enabled.setter
    def sync_secret_enabled(self, value: pulumi.Input[str]):
        pulumi.set(self, "sync_secret_enabled", value)


class SecretsStoreCsiDriver(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 sync_secret_enabled: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a SecretsStoreCsiDriver resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] sync_secret_enabled: Enable synchronization from volumes to Kubernetes secretes.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SecretsStoreCsiDriverArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a SecretsStoreCsiDriver resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param SecretsStoreCsiDriverArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecretsStoreCsiDriverArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 sync_secret_enabled: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecretsStoreCsiDriverArgs.__new__(SecretsStoreCsiDriverArgs)

            if sync_secret_enabled is None and not opts.urn:
                raise TypeError("Missing required property 'sync_secret_enabled'")
            __props__.__dict__["sync_secret_enabled"] = sync_secret_enabled
            __props__.__dict__["application"] = None
            __props__.__dict__["namespace"] = None
        super(SecretsStoreCsiDriver, __self__).__init__(
            'cloud-toolkit-aws:kubernetes:SecretsStoreCsiDriver',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def application(self) -> pulumi.Output['pulumi_kubernetes.apiextensions.CustomResource']:
        return pulumi.get(self, "application")

    @property
    @pulumi.getter
    def namespace(self) -> pulumi.Output[Optional['pulumi_kubernetes.core.v1.Namespace']]:
        return pulumi.get(self, "namespace")

